#define DEBUG
atom/icon='Iconz.dmi'
turf/grass/icon_state="grass"
world/turf=/turf/grass
client/New()
	..()
	winset(src,"map","icon-size=32")
	view=9
obj/HUD
	left/screen_loc="NORTH,WEST"
	middle/screen_loc="NORTH,WEST+1"
	right/screen_loc="NORTH,WEST+2"
	left2/screen_loc="NORTH-1,WEST"
	middle2/screen_loc="NORTH-1,WEST+1"
	right2/screen_loc="NORTH-1,WEST+2"
	New(client/C,sl)
		icon_state=name
		if(sl)screen_loc=sl
		C.screen+=src


mob/icon_state="man"
mob/var/list
	hud=list()
	bighud=list()
mob/var
	hp=0
	maxhp=100
	mp=0
	maxmp=100
mob/verb/Make_A_Hud(n as num)
	if(n<3)n=3
	if(n>17)n=17
	hud+=new /obj/HUD/left(client)
	for(var/v=1 to n)
		hud+=new/obj/HUD/middle(client,"NORTH,WEST+[v]")
	hud+=new /obj/HUD/right(client,"NORTH,WEST+[n+1]")
mob/verb/Make_A_Big_Hud(n as num)
	if(n<3)n=3
	if(n>17)n=17
	bighud+=new /obj/HUD/left2(client)
	for(var/v=1 to n)
		bighud+=new/obj/HUD/middle2(client,"NORTH-1,WEST+[v]")
	bighud+=new /obj/HUD/right2(client,"NORTH-1,WEST+[n+1]")
mob/verb/Add_To_Hud()
	if(!hud.len)return
	var/s=rand(1,6)
	src<<"Recover'd [s] health!"
	hp+=s
	var/percentage
	if(hp)percentage=hp/maxhp
	else percentage=0
	var/hudp=hud.len*percentage
	for(var/obj/o in hud)o.overlays=null
	for(var/v=1 to hudp)
		if(hud.len<v)continue
		var/obj/HUD/h=hud[v]
		for(var/vv=1 to 32)
			if(v==1&&vv==1){continue}
			if(v==hud.len&&vv==32)continue
			var/obj/o=new /obj
			o.icon_state="add"
			o.pixel_x=vv
			h.overlays+=o
	var/p=round(32*hudp)
	while(p>32)p-=32
	if(!round(hudp))hudp=1
	if(round(hudp)+1>hud.len)hudp=hud.len-1
	var/obj/HUD/h=hud[round(hudp)+1]
	for(var/v=1 to p)
		var/obj/o=new /obj
		o.icon_state="add"
		o.pixel_x=v
		h.overlays+=o
	src<<"You have [percentage*100]% health"
	src<<"How much of the hud to fill [hudp] outta [hud.len]"
mob/verb/Subtract_To_Hud()
	if(!hud.len)return
	var/s=rand(1,6)
	src<<"Ouch, that does [s] damage!"
	hp-=s
	var/percentage
	if(hp)percentage=hp/maxhp*100
	else percentage=0
	var/hudp=hud.len*(percentage/100)
	for(var/obj/o in hud)o.overlays=null
	for(var/v=1 to hudp)
		if(hud.len<v)continue
		var/obj/HUD/h=hud[v]
		for(var/vv=1 to 32)
			if(v==1&&vv==1)continue
			if(v==hud.len&&vv==32)continue
			var/obj/o=new /obj
			o.icon_state="add"
			o.pixel_x=vv
			h.overlays+=o
	var/p=round(32*hudp)
	while(p>32)p-=32
	if(!round(hudp))hudp=1
	var/obj/HUD/h=hud[round(hudp)+1]
	for(var/v=1 to p)
		var/obj/o=new /obj
		o.icon_state="add"
		o.pixel_x=v
		h.overlays+=o
	src<<"You have [percentage*100]% health"
	src<<"How much of the hud to fill [hudp] outta [hud.len]"
mob/verb/Add_To_Big_Hud()
	if(!bighud.len)return
	var/s=rand(1,6)
	src<<"Recover'd [s] magic!"
	mp+=s
	var/percentage
	if(mp)percentage=mp/maxmp
	else percentage=0
	var/bighudp=bighud.len*percentage
	for(var/obj/o in bighud)o.overlays=null
	for(var/v=1 to bighudp)
		if(bighud.len<v)continue
		var/obj/HUD/h=bighud[v]
		for(var/vv=1 to 32)
			if(v==1&&vv==1){continue}
			if(v==bighud.len&&vv==32)continue
			var/obj/o=new /obj
			o.icon_state="add2"
			o.pixel_x=vv
			h.overlays+=o
	var/p=round(32*bighudp)
	while(p>32)p-=32
	if(!round(bighudp))bighudp=1
	if(round(bighudp)+1>hud.len)bighudp=bighud.len-1
	var/obj/HUD/h=bighud[round(bighudp)+1]
	for(var/v=1 to p)
		var/obj/o=new /obj
		o.icon_state="add2"
		o.pixel_x=v
		h.overlays+=o
	src<<"You have [percentage*100]% magic"
	src<<"How much of the Hud to fill [bighudp] outta [bighud.len]"
mob/verb/Subtract_To_Big_Hud()
	if(!bighud.len)return
	var/s=rand(1,6)
	src<<"Ouch, that does [s] damage!"
	mp-=s
	var/percentage
	if(mp)percentage=mp/maxmp*100
	else percentage=0
	var/bighudp=bighud.len*(percentage/100)
	for(var/obj/o in bighud)o.overlays=null
	for(var/v=1 to bighudp)
		if(bighud.len<v)continue
		var/obj/HUD/h=bighud[v]
		for(var/vv=1 to 32)
			if(v==1&&vv==1)continue
			if(v==bighud.len&&vv==32)continue
			var/obj/o=new /obj
			o.icon_state="add"
			o.pixel_x=vv
			h.overlays+=o
	var/p=round(32*bighudp)
	while(p>32)p-=32
	if(!round(bighudp))bighudp=1
	var/obj/HUD/h=bighud[round(bighudp)+1]
	for(var/v=1 to p)
		var/obj/o=new /obj
		o.icon_state="add"
		o.pixel_x=v
		h.overlays+=o
	src<<"You have [percentage*100]% magic"
	src<<"How much of the Hud to fill [bighudp] outta [bighud.len]"

